#ifndef __TEMPLATE_H__
#define __TEMPLATE_H__

#include <linux/ioctl.h>

#define TEMPLATE_MAJOR				0
#define TEMPLATE_NR_DEVS			4

extern int template_major;				// template_main.c
extern int template_nr_devs;

void template_create_proc( void );
void template_remove_proc( void );

#define TEMPLATE_IOC_MAGIC				'k'

#define TEMPLATE_IOCRESET				_IO(TEMPLATE_IOC_MAGIC, 0)

#define TEMPLATE_IOCSQUANTUM			_IOW(TEMPLATE_IOC_MAGIC,	1,	int)
#define TEMPLATE_IOCSQSET				_IOW(TEMPLATE_IOC_MAGIC,	2,	int)
#define TEMPLATE_IOCTQUANTUM			_IO(TEMPLATE_IOC_MAGIC,	3)
#define TEMPLATE_IOCTQSET				_IO(TEMPLATE_IOC_MAGIC,	4)
#define TEMPLATE_IOCGQUANTUM			_IOR(TEMPLATE_IOC_MAGIC,	5,	int)
#define TEMPLATE_IOCGQSET				_IOR(TEMPLATE_IOC_MAGIC,	6,	int)
#define TEMPLATE_IOCQQUANTUM			_IO(TEMPLATE_IOC_MAGIC,	7)
#define TEMPLATE_IOCQQSET				_IO(TEMPLATE_IOC_MAGIC,	8)
#define TEMPLATE_IOCXQUANTUM			_IOWR(TEMPLATE_IOC_MAGIC,	9,	int)
#define TEMPLATE_IOCXQSET				_IOWR(TEMPLATE_IOC_MAGIC,	10,	int)
#define TEMPLATE_IOCHQUANTUM			_IO(TEMPLATE_IOC_MAGIC,	11)
#define TEMPLATE_IOCHQSET				_IO(TEMPLATE_IOC_MAGIC,	12)

#define TEMPLATE_P_IOCTSIZE			_IO(TEMPLATE_MAGIC,		13)
#define TEMPLATE_P_IOCQSIZE			_IO(TEMPLATE_MAGIC,		14)

#define TEMPLATE_IOC_MAXNR				14


#endif

